% Article proposed to mdpi-INVENTIONS
% Controller that includes the evolutionary algorithm EAv1.
function Uk=Controller_EA(k)
% The Controller has the following characteristics:
% input parameters: k and x(k)
% output parameter:  (the first element of the best solution
% control horizon: [k H] , with k=0,1,...,H-1 ; H=20;
% number of genes:  H-k (see (8));
% discretization step: T;
% other parameters like in Table 3.

str=sprintf('Controller-one step.m');disp(str);
global kk; %XXXXXXXXXXXXXX
global horiz;
global t_vector;
global N s;
global Nt;
global pop;
global CHILD;
global ngene NGen;
%global xmin xmax;
%global dTdtmax;
global fc fcCHILD;
global amic;
global nr_fii;
global sigma msc mc;
%global X00;
global ti;
global delt;
str=sprintf('#####  k=%d',k);
disp(str);
kk=k;      %XXXXXXXXXXXXXX
fc=zeros(N,1);
fcCHILD=zeros(nr_fii,1);
ngene=Nt-k+1;
ti=(k-1)*delt;

t_vector=ti:delt:horiz; % are Nt+1 elemente

amic=0.7;

R=N:-1:1; % Rangurile populatiei. Solutiile sunt ordonate;
          % miu=N
P=ScaleRank(R,N,s);%P contine rangurile scalate
lambda=nr_fii;
pop=zeros(N,ngene);
CHILD=zeros(nr_fii,ngene);

%Generare populatie initiala
 for i=1:N
    for j=1:ngene     
          pop(i,j)=3.0+random('unif',-j/10, j/10);
    end
 end

%Evaluare initiala
for i=1:N
	fc(i)=eval_EP_single(pop(i,:));
end
[fc,IX]=sort(fc,1,'descend');
 pop=pop(IX,:);
sigma=0.2;
mc=0;
msc=0;

g=1;
%CICLU MARE de T ITERAII
%tttttttttttttttttttttttttttttttttttttttttttttttttttttt BEGIN
while(g<=NGen)         %&&(gasit==0)

% SELECTIE PARINTI
parinti=StUnSamp(P,N,lambda);%indicii parintilor
per=randperm(lambda);
parinti=parinti(per);%permutare aleatorie a indicilor

%INCRUCISARE - atentie aici se construiesc (aparglobal amic;) fii
for ii=1:lambda
      jj=randi(lambda);
      icucine=parinti(jj);
      %icucine=1;
      incrucisare_BLX(parinti(ii),icucine,ii); %un singur copil
      % se creaza CHILD(ii,:)        
end
%-----------------------------
 %MUTATIE (mutatieGaussRH contine si evaluarea)
 for i7=1:lambda
      fcCHILD(i7)=eval_EP_single(CHILD(i7,:));
      %Evalure inainte de mutatie pt toti fii (valabila si daca nu voi face mutatie)
      
      daca_mut=randi(100);
      if(daca_mut<=90)      
        mutatieGaussRH_g(i7); %Fac mutatie pe CHILD(i7)
        %In interior se face si StepCtrl si actualizare fcCHILD(i7)
        %mutSimp(i7,g);
      end
      %fcCHILD(i7)=eval_EP_single(CHILD(i7,:));
 end

 % Copiere fi pe ultimele lambda POZITII din cele N
 pop((N-lambda+1):N,:)=CHILD;
 fc((N-lambda+1):N)=fcCHILD;
 %------------------------------------
 % Reordonare pop dupa fc
 [fc,IX]=sort(fc,1,'descend');
 pop=pop(IX,:);   %reordoneaza
if (mod(g,10)==0)
    str=sprintf('#####   nr. gen=%g Jmax=%g sigma=%g',g, fc(1),sigma);
    disp(str);
 end
 %------------------------------------
 
 g=g+1;
end     %while
Uk=pop(1,1);
%save('WspEA_EP_single');
end


